-- name: [CS] Floragato
-- description: "meow"\n\n\\#2F5F36\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_Flora = smlua_model_util_get_id("Flora_geo")

local TEX_Flora_ICON = get_texture_info("Flora-icon")

local TEXT_MOD_NAME = "Floragato"

local VOICETABLE_Flora = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'off.ogg',
    [CHAR_SOUND_OOOF2] = 'oofff.ogg',
    [CHAR_SOUND_WAH2] = nil,
    [CHAR_SOUND_PUNCH_YAH] = 'pung.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'off.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'idkwheretousethis.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'jump.ogg','jump2.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'jump2.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Awwwww.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'bonk.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'grabbingedge.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = nil, -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'Awwwww.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'bonk.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'grabbingedge.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = nil, -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'longfall.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Awwwww.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'idkwheretousethis.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'getstart.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'idkwheretousethis.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'pain.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = nil, -- Low health
    [CHAR_SOUND_ON_FIRE] = 'burning.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'dyinglmao.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'idkwheretousethis.ogg' -- Booted out of level
}

local PALETTE_Flora = {
    [PANTS]  = "2F5F36",
    [SHIRT]  = "F19CAF",
    [GLOVES] = "61BB4E",
    [SHOES]  = "CCA1B3",
    [HAIR]   = "2F5F36",
    [SKIN]   = "D7EBC3",
    [CAP]    = "C35671",
}

local CAPTABLE_Flora = {
    normal = smlua_model_util_get_id("Flora_cap_normal_geo"),
    wing = smlua_model_util_get_id("Flora_cap_wing_geo"),
    metal = smlua_model_util_get_id("Flora_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("Flora_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Floragato", "Boastful and mischievous, and always looking for attention and company", "Made by @Asplatim on twitter", {r = 47, g = 95, b = 54}, E_MODEL_Flora, CT_MARIO, TEX_Flora_ICON)
     _G.charSelect.character_add_caps(E_MODEL_Flora, CAPTABLE_Flora)

    _G.charSelect.character_add_palette_preset(E_MODEL_Flora, PALETTE_Flora)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_Flora, VOICETABLE_Flora)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Flora then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_Flora then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end